import javax.microedition.lcdui.*;
import java.lang.Runtime;

public class findResult extends Form implements CommandListener, ItemCommandListener {
 private midlet midlet;
 private Display dpy;
 private Displayable prev;

 private Command cmdOK, cmdPress;
 private StringItem item;
 private ImageItem iitem;
 private Image img;
 private String [] markers = {
  "t", "r", "p", "q", "R", "L", "b", "o"
 };
 private String [] words;
 private findForm ff;
 private int numWords;
 public static String upperStr =
  "ABWGDEVZIJKLMNOPRSTUFHCQYXŨ";
 public static String lowerStr =
  "abwgdevzijklmnoprstufhcqyx";
 private static final int allRools = 169;
 private static final int allSigns = 266;

 public findResult (midlet midlet, findForm ff, String fs) {
  super("");
  this.midlet = midlet;
  this.ff=ff;
  dpy = Display.getDisplay(midlet);
  prev = dpy.getCurrent();
  cmdPress=new Command("", Command.ITEM, 1);

  // 
  int k,i=0,p=-1,p2=-1,t,j;
  //    
  if (fs.length()>0) {
   k=countOfChar (fs,' ');
   numWords=k+1;
   words = new String [numWords];
   do {
    p=fs.indexOf (' ');
    if (p==-1) t=fs.length(); 
    else t=p;
    words[i++]=fs.substring (0,t);
    if (p==-1) break;
    fs=fs.substring(p+1);
   } while (true);
  }
  //   
  int percent=1;
  if (options.mode==0) {
   for (i=0; i<24; i++) {
    for (j=0; j<data.points[i]; j++) {
    ff.setTitle (": "+(percent++)+"/"+allRools);
     int count=0;
     for (k=0; k<numWords; k++) {
      p=toUpperCase(data.chapterText[i][j]).indexOf (toUpperCase(words[k]));
      if (p>-1) {
       if (options.searchmode==1) { //
        if (appendItem (this,i,j)==false) {
         i=24; j=data.points[i]; break;
        }
        break;
       }
       else count++; //
      }
     }
     if ((options.searchmode==0) && (count==numWords)) {
      if (appendItem (this,i,j)==false) {
       i=24; break;
      }
     }
    }
   }
  }
  //     
  else if (options.mode==1) {
   for (i=0; i<8; i++) {
    for (j=0; j<data.signsImages[i]; j++) {
     ff.setTitle (": "+(percent++)+"/"+allSigns);
     for (k=0; k<8; k++) {
      if ((options.imgmode[k]>0) && (data.signsNames[i][j].startsWith(markers[k])==true)) {
       int count=0;
       if (fs.length()>0) { //    ,    ,     
        for (t=0; t<numWords; t++) {
         p=toUpperCase(data.signsNames[i][j]).indexOf (toUpperCase(words[t]));
         p2=findInSignText (i,j,toUpperCase(words[t]));
         if ( (p>-1) || (p2>-1)) {
          if (options.searchmode==1) { //
           if (appendImageItem (this,i,j)==false) {
            j=data.signsImages[i]; i=8; k=8; break;
           }
           break;
          }
          else count++; //
         }
        }
        if ((options.searchmode==0) && (count==numWords)) {
         if (appendImageItem (this,i,j)==false) {
          j=data.signsImages[i]; i=8; break;
         }
         continue;
        }
       }
       else {
        if (appendImageItem (this,i,j)==false) {
         j=data.signsImages[i]; i=8; break;
        }
       }
      }
     }
    }
   }
  }
  //  
  if (size()==0) {
   append (new StringItem ("","  "));
  }

  cmdOK = new Command ("", Command.BACK, 1);
  addCommand(cmdOK);
  setCommandListener(this);
  setTitle (" ");
  dpy.setCurrent(this);
 }

 public int findInSignText (int i, int j, String t) {
  int p=data.signsNames[i][j].indexOf (' ');
  String s=data.signsNames[i][j].substring (1,p);
  int p1=s.indexOf ('.');
  int p2=s.lastIndexOf ('.');
  if (p1==p2) p2=s.length();
  int ip=Integer.parseInt (s.substring(0,p1));
  int jp=Integer.parseInt (s.substring(p1+1,p2));
  return toUpperCase(data.signsNotes[ip-1][jp-1]).indexOf (t);
 }

 public int countOfChar (String s, int c) {
  int k=0;
  for (int i=0; i<s.length(); i++) {
   if (s.charAt(i)==c) k++;
  }
  return k;
 }

 public String toUpperCase(String in) {
  String out="";
  char c; 
  int n;
  for (int i=0; i<in.length(); i++) {
   c=in.charAt (i);
   n=lowerStr.indexOf(c);
   if (n>-1) out+=upperStr.charAt(n);
   else out+=c;
  }
  return out;
 }

 private void freeMemo (findResult form) {
  Runtime runtime = Runtime.getRuntime();
  long free=runtime.freeMemory();
  dpy.setCurrent (new Alert ("","  ("+free+" )   .  ,    ",null,AlertType.ERROR),form);
  int size = form.size();
  if (size > 0) form.delete (size-1);
  runtime.gc();
 }

 private boolean appendItem (findResult form, int i, int j) { //    
  int p, k=32;
  if (data.chapterText[i][j].length()<k) k=data.chapterText[i][j].length();
  try {
   p = data.chapterText[i][j].indexOf (' ');
   k += p;
   item=new StringItem (""+(i+1)+"."+(j+1),data.chapterText[i][j].substring(p,k)+"...");
   item.addCommand(cmdPress);
   item.setDefaultCommand(cmdPress);
   item.setItemCommandListener(this);
   form.append (item);
  }
  catch (OutOfMemoryError err) {
   freeMemo (form);
   return false;
  }
  return true;
 }

 private boolean appendImageItem (findResult form, int i, int j) { //    
  String st=data.signsNames[i][j].substring(1);
  int p=st.indexOf(' ');
  try {
   try {
    img=Image.createImage("/"+st.substring(0,p)+".png");
   }
   catch (java.io.IOException e) {}
   iitem=new ImageItem (st, img, Item.LAYOUT_CENTER, "");
   iitem.addCommand(cmdPress);
   iitem.setDefaultCommand(cmdPress);
   iitem.setItemCommandListener(this);
   form.append (iitem);
  }
  catch (OutOfMemoryError err) {
   freeMemo (form);
   return false;
  }
  return true;
 }

 public void commandAction(Command c, Displayable d) {
  if (c==cmdOK) {
   ff.setTitle (" "+(options.mode==0 ? "": ""));
   dpy.setCurrent(prev);
  }
 }

 public void commandAction (Command c, Item i) {
  if (c==cmdPress) { 
   if (options.mode==0) {
    String s=i.getLabel();
    int p=s.indexOf('.');
    int chapter= Integer.parseInt(s.substring (0,p));
    int number=Integer.parseInt(s.substring (p+1));
    pointForm point = new pointForm (midlet, chapter, number);
    dpy.setCurrent (point);
   }
   else if (options.mode==1) {
    String s=i.getLabel().substring (0,i.getLabel().indexOf(" "));
    int p=s.indexOf('.');
    int p2=s.lastIndexOf('.');
    int chapter=Integer.parseInt(s.substring(0,p));
    int number, subnumber;
    if (p==p2) {
     number=Integer.parseInt(s.substring(p+1));
     subnumber=0;
    }
    else {
     number=Integer.parseInt(s.substring(p+1,p2));
     subnumber=Integer.parseInt(s.substring(p2+1));
    }
    s=""+chapter+"."+number;
    if (subnumber!=0) s+= "."+subnumber;
    signForm sign = new signForm (midlet,s,chapter,number,subnumber);
    dpy.setCurrent (sign);
   }
  }
 }

}
